#ifndef TriangleNeighborFinder_h
#define TriangleNeighborFinder_h

#include "GridGenerator/global.h"


#include <vector>

struct Triangle;
struct Vertex;
struct Geometry;

struct IntegerPtr2D {
    int *ptr;
    int size;
    int DIM;
};

class TriangleNeighborFinder
{
public:
    VF_PUBLIC TriangleNeighborFinder(Triangle *triangles_ptr, int size);
    VF_PUBLIC ~TriangleNeighborFinder();
    
    void VF_PUBLIC fillWithNeighborIndices(IntegerPtr2D *indices, Triangle *triangles);
	void VF_PUBLIC fillWithNeighborAngles(Geometry *geom) const;

private:
    void initalSortedInSpaceWithCoords(Triangle *triangles_ptr, int size);
    void fillSortedInSpaceWithFirstVertexAndCoordinateIDs(int numberOfRows);
    void fillVectorWithIndicesOfTriangleNeighbors();
    unsigned int findTriangleID(unsigned int uniqueCoordID);
    Vertex getCoordinatesIDfromTriangle(int triangleID);
    bool isNeighborNotAlreadyInside(unsigned int iTriangle, unsigned int jTriangle);
    std::vector<std::vector<unsigned int> > indicesOfTriangleNeighbors;

    bool isTriangleNeighborOfParentTriangle(Vertex, Vertex);

    int numberOfRows;
    real **sortedToTriangles;
    real **sortedInSpace;
};

#endif
